/// <reference path="../../src/externals/bluebird.d.ts" />
export interface IState {
}
export interface IAction {
    execute(state: IState): IState;
}
export interface IAsyncAction {
    execute(state: IState, resolve: (value?: IState) => void, reject: (errors?: any) => void): void;
}
export interface IStore {
    dispatch(action: IAction | ((state: IState) => IState)): IState;
    dispatchAsync(action: IAsyncAction | ((state: IState, resolve: (value?: IState) => void, reject: (errors?: any) => void) => void)): Promise<IState>;
    getState<TState extends IState>(): TState;
}
