import * as Promise from "bluebird";
import { IState, IAction, IAsyncAction, IStore } from "./";
import { IStateListener, IStateNotifier } from "./../observer";
export declare class Store implements IStore, IStateNotifier {
    private state;
    private notifier;
    private cloneState();
    private updateState(state);
    constructor(initialState: IState);
    dispatch(action: IAction | ((state: IState) => IState)): IState;
    dispatchAsync(action: IAsyncAction | ((state: IState, resolve: (value?: IState) => void, reject: (errors?: any) => void) => void)): Promise<IState>;
    getState<TState extends IState>(): TState;
    subscribe(listener: IStateListener): void;
}
